---
title: Game
date: 11-06-2020

I've been working on a simple physics game in C for about a year now.

It's been a really enjoyable project to work on in pieces every now and again. 
I hope to at some point implement procedurally generated levels, and some 
tangible gameplay challenges but that is subject to further game design decisions.

Up until now I've mainly been 
interested in getting the physics system working, and just used SDL2 lines and 
shapes to illustrate what is happening. I'm not sure I want to go and learn 
OpenGL, but I think it might be time to make it look a bit nicer. 

My immediate plan is to improve the graphical presentation, keeping the flat-shaded
shapes though for stylistic reasons. To that end I wrote this 
[colour manipulation code](https://git.topost.net/alistair/c-colours) as a 
start for creating analagous colour palettes.

What with University I don't have time to go into details, so here's a little 
demo:

```{=html}
 <video width=100% autoplay loop>
  <source src="https://alistairmichael.com/media/coolfungame.mp4" type="video/mp4">
</video> 

 <video width=100% autoplay loop>
  <source src="https://alistairmichael.com/media/gamebounce.mp4" type="video/mp4">
</video> 
```


[Source code](https://git.topost.net/alistair/space_game)

