---
title: Cowsay C
date: 10-06-2020
...

Back in February I was bored on an aeroplane so I decided to re-write the classic 
`cowsay` by Tony Monroe. I wrote it in C, as a sort of private joke about premature
optimisation, I guess, and because for some reason puzzling over twiddly text-formatting
problems in C is good at keeping me awake after getting up at 4am to go to the 
airport.

The trickiest part of this was text-wrapping. The trivial solution is to loop 
through the input string and replace every whitespace with a newline character, 
but that doesn't allow breaking on `'\t'` or `-`, or other printing characters. I 
tried to get it as close as possible to the real Cowsay, which uses the Perl 
text wrapping function, but there are still some divergences that I can't explain. 
There also proved to be some edge cases with attempting to put the wrapped text 
into a box but I think I got them worked out in the end[^1].

It does not support multiple cow types or changing the features of the cow, 
(`$eyes`) it might be nice to add that at some point but I'm not sure how much 
time I really want to spend on this program.

[^1]: I have just discovered that it doesn't understand tabs, so I either have to 
fix that or live with this dissatisfaction now.

Anyway it was a good bit of fun for the down moments in my trip to Melbourne. 
I cannot attest to the code quality, I remember being extremely tired and 
bleary when I wrote it.

```
 _________________________________________
/ `How do you feel?' he asked him.        \
| `Like a military academy,' said Arthur, |
| `bits of me keep                        |
| passing out.'" ....                     |
| `We're safe,' he said.                  |
| `Oh good,' said Arthur.                 |
| `We're in a small galley cabin,' said   |
| Ford, `in one of the                    |
| spaceships of the Vogon Constructor     |
| Fleet.'                                 |
| `Ah,' said Arthur, `this is obviously   |
| some strange usage of                   |
| the word "safe" that I wasn't           |
| previously aware of.'                   |
|                                         |
| - Arthur after his first ever teleport  |
\ ride.                                   /
 -----------------------------------------
        \   ^__^
         \  (oo)\_______
            (__)\       )\/\
                ||----w |
                ||     ||
```

[source link](https://git.topost.net/alistair/c-cowsay)

